/*
 *  Copyright (c) 2015, Facebook, Inc.
 *  All rights reserved.
 *
 *  This source code is licensed under the BSD-style license found in the
 *  LICENSE file in the root directory of this source tree. An additional grant
 *  of patent rights can be found in the PATENTS file in the same directory.
 *
 */

/**
 * @flow
 */
"use strict";


                 
                       
                           

  function Documentation() {
    this.$Documentation_props = {};
    this.$Documentation_description = '';
    this.$Documentation_composes = [];
  }

  Object.defineProperty(Documentation.prototype,"addComposes",{writable:true,configurable:true,value:function(moduleName        ) {
    if (this.$Documentation_composes.indexOf(moduleName) === -1) {
      this.$Documentation_composes.push(moduleName);
    }
  }});

  Object.defineProperty(Documentation.prototype,"getDescription",{writable:true,configurable:true,value:function()         {
    return this.$Documentation_description;
  }});

  Object.defineProperty(Documentation.prototype,"setDescription",{writable:true,configurable:true,value:function(description        )       {
    this.$Documentation_description = description;
  }});

  Object.defineProperty(Documentation.prototype,"getPropDescriptor",{writable:true,configurable:true,value:function(propName        )                 {
    var propDescriptor = this.$Documentation_props[propName];
    if (!propDescriptor) {
      propDescriptor = this.$Documentation_props[propName] = {};
    }
    return propDescriptor;
  }});

  Object.defineProperty(Documentation.prototype,"toObject",{writable:true,configurable:true,value:function()         {
    var obj = {
      description: this.$Documentation_description,
      props: this.$Documentation_props
    };

    if (this.$Documentation_composes.length) {
      obj.composes = this.$Documentation_composes;
    }
    return obj;
  }});


module.exports = Documentation;
